/* MyOpenGLVideoView */

#import <Cocoa/Cocoa.h>
#import <QuickTime/QuickTime.h>
#include <OpenGL/gl.h>
#include <OpenGL/glu.h>
#include </sw/include/opencv/cv.h>
#include <stdlib.h>



@interface MyOpenGLVideoView : NSOpenGLView
{
	bool Sobel;
	bool removeBackground;
	bool recordBackground;

	//stuff for OpenGL-Display
	NSPoint mousePoint ;
	GLuint videoTexture;
	GLuint texX, texY; // needs to be power of 2
	float angleX, angleY;
	float rotation;	
	
	//Stuff for QuickTime
	NSTimer 			*gMyTimer;		// our timer for idling the sequence grabber
    
	SeqGrabComponent	gSeqGrab;		// the sequence grabber component
    SGChannel			gSGChanVideo;	// the sequence grabber channel component
	GWorldPtr			offScreen;		// Offscreen gworld used for decompression
	Rect				gBoundsRect;	// rect we are drawing into
	ImageSequence 		gDecomSeq;		// unique identifier for our decompression sequence

    long				gImageSize;		// size of the image in our buffer to draw
	
	//Stuff for OpenCV
	CvSize CVImageSize;
	IplImage * source;
	IplImage * runningSource;
	IplImage * result;
	IplImage * work;
	IplImage * backgroundMean;
	IplImage * backgroundVariance3;
	int nrOfBackgroundImages;
	IplImage * backgroundSum;
	IplImage * backgroundSquaredSum;


	//spatial smoothing
	IBOutlet NSTextField * alpha;
	IBOutlet NSTextField * threshold;
	float a;

	
	//"transfer OpenCV -> openGL
	CvSize glSize;
	IplImage * workGL;
	
}
- (IBAction)toggleSobel:(id)sender;
- (IBAction)toggleRecordingOfBackground:(id)sender;
- (IBAction)toggleBackgroundRemoval:(id)sender;

- (id) initWithCoder: (NSCoder *) coder ;
- (void) dealloc ;

//User Interaction...
- (void) mouseDown: (NSEvent *) theEvent ;
- (void) mouseDragged: (NSEvent *) theEvent ;

//OpenGL stuff
- (void) updateImage:(char*)texture;
- (void) drawRect: (NSRect) bounds ;

//QT Stuff
-(void) sgIdleTimer:(id)sender;
-(OSErr) doSeqGrab:(NSRect)grabRect;
-(void) endGrab;

//Access from Callback...
-(void)doImageProcessing;

-(GWorldPtr)gworld;
-(ImageSequence)decomSeq;
-(SGChannel)sgChanVideo;
-(Rect)boundsRect;

-(IplImage *)getSource;

@end

//lowest Level Callback for QT...
pascal OSErr mySGDataProc(SGChannel c, 
						  Ptr p,
						  long len,
						  long *offset,
						  long chRefCon,
						  TimeValue time,
						  short writeType, 
						  long refCon);
void saveOpenGLVideoViewObjectForCallback(void *theObject);


